LOGINCTL(1)

NAME
loginctl - Control the elogind login manager

SYNOPSIS

loginctl [OPTIONS...] {COMMAND} [NAME...]

/lib/elogind/system-shutdown

/lib/elogind/system-sleep

DESCRIPTION

loginctl may be used to introspect and control the state of the elogind(8) login manager

COMMANDS

The following commands are understood:

  Session Commands

list-sessions
    List current sessions.

session-status [ID...]
    Show terse runtime status information about one or more sessions, followed by the most recent log data from the journal. Takes one or more session identifiers as parameters. If no session identifiers are passed, the status of the caller's session is shown. This function is intended to generate human-readable output. If you are looking for computer-parsable output, use show-session instead.

show-session [ID...]
    Show properties of one or more sessions or the manager itself. If no argument is specified, properties of the manager will be shown. If a session ID is specified, properties of the session are shown. By default, empty properties are suppressed. Use --all to show those too. To select specific properties to show, use --property=. This command is intended to be used whenever computer-parsable output is required. Use session-status if you are looking for formatted human-readable output.

activate [ID]
    Activate a session. This brings a session into the foreground if another session is currently in the foreground on the respective seat. Takes a session identifier as argument. If no argument is specified, the session of the caller is put into foreground.

lock-session [ID...], unlock-session [ID...]
    Activates/deactivates the screen lock on one or more sessions, if the session supports it. Takes one or more session identifiers as arguments. If no argument is specified, the session of the caller is locked/unlocked.

lock-sessions, unlock-sessions
    Activates/deactivates the screen lock on all current sessions supporting it.

terminate-session ID...
    Terminates a session. This kills all processes of the session and deallocates all resources attached to the session. If the argument is specified as empty string the session invoking the command is terminated.

kill-session ID...
    Send a signal to one or more processes of the session. Use --kill-whom= to select which process to kill. Use --signal= to select the signal to send. If the argument is specified as empty string the signal is sent to the session invoking the command.

  User Commands

list-users
    List currently logged in users.

user-status [USER...]
    Show terse runtime status information about one or more logged in users, followed by the most recent log data from the journal. Takes one or more user names or numeric user IDs as parameters. If no parameters are passed, the status is shown for the user of the session of the caller. This function is intended to generate human-readable output. If you are looking for computer-parsable output, use show-user instead.

show-user [USER...]
    Show properties of one or more users or the manager itself. If no argument is specified, properties of the manager will be shown. If a user is specified, properties of the user are shown. By default, empty properties are suppressed. Use --all to show those too. To select specific properties to show, use --property=. This command is intended to be used whenever computer-parsable output is required. Use user-status if you are looking for formatted human-readable output.

terminate-user USER...
    Terminates all sessions of a user. This kills all processes of all sessions of the user and deallocates all runtime resources attached to the user. If the argument is specified as empty string the sessions of the user invoking the command are terminated.

kill-user USER...
    Send a signal to all processes of a user. Use --signal= to select the signal to send. If the argument is specified as empty string the signal is sent to the sessions of the user invoking the command.

  Seat Commands

list-seats
    List currently available seats on the local system.

seat-status [NAME...]
    Show terse runtime status information about one or more seats. Takes one or more seat names as parameters. If no seat names are passed the status of the caller's session's seat is shown. This function is intended to generate human-readable output. If you are looking for computer-parsable output, use show-seat instead.

show-seat [NAME...]
    Show properties of one or more seats or the manager itself. If no argument is specified, properties of the manager will be shown. If a seat is specified, properties of the seat are shown. By default, empty properties are suppressed. Use --all to show those too. To select specific properties to show, use --property=. This command is intended to be used whenever computer-parsable output is required. Use seat-status if you are looking for formatted human-readable output.

attach NAME DEVICE...
    Persistently attach one or more devices to a seat. The devices should be specified via device paths in the /sys/ file system. To create a new seat, attach at least one graphics card to a previously unused seat name. Seat names may consist only of a–z, A–Z, 0–9, "-" and "_" and must be prefixed with "seat". To drop assignment of a device to a specific seat, just reassign it to a different seat, or use flush-devices.

flush-devices
    Removes all device assignments previously created with attach. After this call, only automatically generated seats will remain, and all seat hardware is assigned to them.

terminate-seat NAME...
    Terminates all sessions on a seat. This kills all processes of all sessions on the seat and deallocates all runtime resources attached to them.

  System Commands

reload
    Reload the elogind configuration. While the daemon is being reloaded, all sockets elogind listens on behalf of user configuration will stay accessible.

poweroff
    Shut down and power-off the system. This is mostly equivalent to shutdown -h. This command is asynchronous; it will return after the power-off operation is enqueued, without waiting for it to complete.

reboot [--firmware-setup]
    Shut down and reboot the system. This is mostly equivalent to shutdown -r. This command is asynchronous; it will return after the reboot operation is enqueued, without waiting for it to complete.

    If the optional argument --firmware-setup is given, indicate to the system's firmware to reboot into the firmware setup interface. Note that this functionality is not available on all systems.

suspend
    Suspend the system. This will tell all processes registered via dbus to prepare for suspension. This command is asynchronous, and will return after the suspend operation is successfully enqueued. It will not wait for the suspend/resume cycle to complete.

hibernate
    Hibernate the system. This will tell all processes registered via dbus to prepare for hibernation. This command is asynchronous, and will return after the hibernation operation is successfully enqueued. It will not wait for the hibernate/thaw cycle to complete.

hybrid-sleep
    Hibernate and suspend the system. This will tell all processes registered via dbus to prepare for hybrid-sleep. This command is asynchronous, and will return after the hybrid sleep operation is successfully enqueued. It will not wait for the sleep/wake-up cycle to complete.

suspend-then-hibernate
    Suspend the system and hibernate it after the delay specified in logind.conf. This will tell all processes registered via dbus to prepare for suspend-then-hibernate. This command is asynchronous, and will return after the hybrid sleep operation is successfully enqueued. It will not wait for the sleep/wake-up or hibernate/thaw cycle to complete.

  Hook directories

[/usr]/lib[64]/elogind/system-sleep/, /etc/elogind/system-sleep/
    Immediately before entering system suspend and/or hibernation elogind will run all executables in [/usr]/lib[64]/elogind/system-sleep/ and /etc/elogind/system-sleep/ and pass two arguments to them. The first argument will be "pre", the second either "suspend", "hibernate", "hybrid-sleep", or "suspend-then-hibernate", depending on the chosen action. Immediately after leaving system suspend and/or hibernation the same executables are run, but the first argument is now "post". All executables in this directory are executed sequentially, and execution of the action is not continued until all executables have finished.

[/usr]/lib[64]/elogind/system-shutdown/, /etc/elogind/system-shutdown/
    Immediately before rebooting or powering the system off, elogind will run all executables in [/usr]/lib[64]/elogind/system-shutdown/ and /etc/elogind/system-shutdown/ and pass one argument to them. The argument will either be "poweroff" or "reboot", depending on the chosen action.

AllowPowerOffInterrupts, AllowSuspendInterrupts
    Whether the executables in these directories run successfully or not is of no concern to elogind. If you want the scripts to cause the action to be cancelled if one fails, you can set "AllowPowerOffInterrupts" and/or "AllowSuspendInterrupts" to "yes" in /etc/elogind/logind.conf. For this to work the executables in question must print an error message to "STDOUT" that begins with either of these keywords: "CANCELLED", "CRITICAL", "ERROR" or "FAILED". If you want any of these words in a message without causing the action to be cancelled, just re-arrange the sentence in question so that the keyword is not the first word.

BroadcastPowerOffInterrupts, BroadcastSuspendInterrupts
    By default an interrupt of a power off or a suspend is broadcasted. If you do not whish these broadcasts to happen, change "BroadcastPowerOffInterrupts" and/or "BroadcastSuspendInterrupts" to "no" in /etc/elogind/logind.conf.

Note that scripts or binaries dropped in any of the hook directories are intended for local use only and should be considered hacks. If applications want to react to these system commands, they should rather use the Inhibitor interface[1].

OPTIONS

The following options are understood:

--no-ask-password
    Do not query the user for authentication for privileged operations.

-p, --property=
    When showing session/user/seat properties, limit display to certain properties as specified as argument. If not specified, all set properties are shown. The argument should be a property name, such as "Sessions". If specified more than once, all properties with the specified names are shown.

--value
    When showing session/user/seat properties, only print the value, and skip the property name and "=".

-a, --all
    When showing session/user/seat properties, show all properties regardless of whether they are set or not.

-l, --full
    Do not ellipsize process tree entries.

--kill-whom=
    When used with kill-session, choose which processes to kill. Must be one of leader, or all to select whether to kill only the leader process of the session or all processes of the session. If omitted, defaults to all.

-s, --signal=
    When used with kill-session or kill-user, choose which signal to send to selected processes. Must be one of the well known signal specifiers, such as SIGTERM, SIGINT or SIGSTOP. If omitted, defaults to SIGTERM.

    The special value "help" will list the known values and the program will exit immediately, and the special value "list" will list known values along with the numerical signal numbers and the program will exit immediately.

-o, --output=
    When used with user-status and session-status, controls the formatting of the journal entries that are shown. For the available choices, see journalctl(1). Defaults to "short".

-c
    Cancel a pending shutdown or reboot.

-i, --ignore-inhibitors
    When system shutdown or a sleep state is requested, ignore inhibitor locks. Applications can establish inhibitor locks to avoid that certain important operations (such as CD burning or suchlike) are interrupted by system shutdown or a sleep state. Any user may take these locks and privileged users may override these locks. If any locks are taken, shutdown and sleep state requests will normally fail (unless privileged) and a list of active locks is printed. However, if --ignore-inhibitors is specified, the established locks are ignored and not shown, and the operation attempted anyway, possibly requiring additional privileges.

--dry-run
    Just print what would be done. Currently supported by verbs halt, poweroff, reboot, suspend, hibernate, hybrid-sleep, and suspend-then-hibernate.

--no-wall
    Do not send wall messages before halt, power-off and reboot.

-H, --host=
    Execute the operation remotely. Specify a hostname, or a username and hostname separated by "@", to connect to. The hostname may optionally be suffixed by a port ssh is listening on, separated by ":", and then a container name, separated by "/", which connects directly to a specific container on the specified host. This will use SSH to talk to the remote machine manager instance. Container names may be enumerated with machinectl -H HOST. Put IPv6 addresses in brackets.

-M, --machine=
    Execute operation on a local container. Specify a container name to connect to, optionally prefixed by a user name to connect as and a separating "@" character. If the special string ".host" is used in place of the container name, a connection to the local system is made (which is useful to connect to a specific user's user bus: "--user --machine=lennart@.host"). If the "@" syntax is not used, the connection is made as root user. If the "@" syntax is used either the left hand side or the right hand side may be omitted (but not both) in which case the local user name and ".host" are implied.

--no-pager
    Do not pipe output into a pager.

--no-legend
    Do not print the legend, i.e. column headers and the footer with hints.

-h, --help
    Print a short help text and exit.

--version
    Print a short version string and exit.

EXIT STATUS

On success, 0 is returned, a non-zero failure code otherwise.

EXAMPLES

Example 1. Querying user status

    $ loginctl user-status
    sed (1004)
               Since: Wed 2020-01-29 20:32:00 CET; 3 days ago
               State: active
            Sessions: 3 *2
              Linger: no
                Unit: user-1004.slice

There are two sessions, 2 and 3. The session 2 is a graphical session, marked with a star. Uptime, state, lingering state und the user unit are shown. The user unit is an artificial construct, elogind does not really support systemd units and slices.

ENVIRONMENT

$SYSTEMD_LOG_LEVEL
    The maximum log level of emitted messages (messages with a higher log level, i.e. less important ones, will be suppressed). Either one of (in order of decreasing importance) emerg, alert, crit, err, warning, notice, info, debug, or an integer in the range 0...7. See syslog(3) for more information.

$SYSTEMD_LOG_COLOR
    A boolean. If true, messages written to the tty will be colored according to priority.

    This setting is only useful when messages are written directly to the terminal, because journalctl(1) and other tools that display logs will color messages based on the log level on their own.

$SYSTEMD_LOG_TIME
    A boolean. If true, console log messages will be prefixed with a timestamp.

    This setting is only useful when messages are written directly to the terminal or a file, because journalctl(1) and other tools that display logs will attach timestamps based on the entry metadata on their own.

$SYSTEMD_LOG_LOCATION
    A boolean. If true, messages will be prefixed with a filename and line number in the source code where the message originates.

    Note that the log location is often attached as metadata to journal entries anyway. Including it directly in the message text can nevertheless be convenient when debugging programs.

$SYSTEMD_LOG_TID
    A boolean. If true, messages will be prefixed with the current numerical thread ID (TID).

    Note that the this information is attached as metadata to journal entries anyway. Including it directly in the message text can nevertheless be convenient when debugging programs.

$SYSTEMD_LOG_TARGET
    The destination for log messages. One of console (log to the attached tty), console-prefixed (log to the attached tty but with prefixes encoding the log level and "facility", see syslog(3), kmsg (log to the kernel circular log buffer), journal (log to the journal), journal-or-kmsg (log to the journal if available, and to kmsg otherwise), auto (determine the appropriate log target automatically, the default), null (disable log output).

$SYSTEMD_PAGER
    Pager to use when --no-pager is not given; overrides $PAGER. If neither $SYSTEMD_PAGER nor $PAGER are set, a set of well-known pager implementations are tried in turn, including less(1) and more(1), until one is found. If no pager implementation is discovered no pager is invoked. Setting this environment variable to an empty string or the value "cat" is equivalent to passing --no-pager.

    Note: if $SYSTEMD_PAGERSECURE is not set, $SYSTEMD_PAGER (as well as $PAGER) will be silently ignored.

$SYSTEMD_LESS
    Override the options passed to less (by default "FRSXMK").

    Users might want to change two options in particular:

    K
        This option instructs the pager to exit immediately when Ctrl+C is pressed. To allow less to handle Ctrl+C itself to switch back to the pager command prompt, unset this option.

        If the value of $SYSTEMD_LESS does not include "K", and the pager that is invoked is less, Ctrl+C will be ignored by the executable, and needs to be handled by the pager.

    X
        This option instructs the pager to not send termcap initialization and deinitialization strings to the terminal. It is set by default to allow command output to remain visible in the terminal even after the pager exits. Nevertheless, this prevents some pager functionality from working, in particular paged output cannot be scrolled with the mouse.

    See less(1) for more discussion.

$SYSTEMD_LESSCHARSET
    Override the charset passed to less (by default "utf-8", if the invoking terminal is determined to be UTF-8 compatible).

$SYSTEMD_PAGERSECURE
    Takes a boolean argument. When true, the "secure" mode of the pager is enabled; if false, disabled. If $SYSTEMD_PAGERSECURE is not set at all, secure mode is enabled if the effective UID is not the same as the owner of the login session, see geteuid(2) and sd_pid_get_owner_uid(3). In secure mode, LESSSECURE=1 will be set when invoking the pager, and the pager shall disable commands that open or create new files or start new subprocesses. When $SYSTEMD_PAGERSECURE is not set at all, pagers which are not known to implement secure mode will not be used. (Currently only less(1) implements secure mode.)

    Note: when commands are invoked with elevated privileges, for example under sudo(8) or pkexec(1), care must be taken to ensure that unintended interactive features are not enabled. "Secure" mode for the pager may be enabled automatically as describe above. Setting SYSTEMD_PAGERSECURE=0 or not removing it from the inherited environment allows the user to invoke arbitrary commands. Note that if the $SYSTEMD_PAGER or $PAGER variables are to be honoured, $SYSTEMD_PAGERSECURE must be set too. It might be reasonable to completely disable the pager using --no-pager instead.

$SYSTEMD_COLORS
    Takes a boolean argument. When true, systemd and related utilities will use colors in their output, otherwise the output will be monochrome. Additionally, the variable can take one of the following special values: "16", "256" to restrict the use of colors to the base 16 or 256 ANSI colors, respectively. This can be specified to override the automatic decision based on $TERM and what the console is connected to.

$SYSTEMD_URLIFY
    The value must be a boolean. Controls whether clickable links should be generated in the output for terminal emulators supporting this. This can be specified to override the decision that systemd makes based on $TERM and other conditions.

SEE ALSO

elogind(8), logind.conf(5)

NOTES

1.  Inhibitor interface
    https://www.freedesktop.org/wiki/Software/systemd/inhibit